;==========================================================================
;
;   IMPORTANT: For the PIC18 devices, the __CONFIG directive has been
;              superseded by the CONFIG directive.  The following settings
;              are available for this device.
;
;=====  CONFIG1H  =====
;   Oscillator Selection bits:
;     OSC = LP             LP oscillator
;     OSC = XT             XT oscillator
;     OSC = HS             HS oscillator
;     OSC = RC             External RC oscillator, CLKO function on RA6
;     OSC = EC             EC oscillator, CLKO function on RA6
;     OSC = ECIO6          EC oscillator, port function on RA6
;     OSC = HSPLL          HS oscillator, PLL enabled (Clock Frequency = 4 x FOSC1)
;     OSC = RCIO6          External RC oscillator, port function on RA6
CONFIG OSC = INTIO67;      Internal oscillator block, port function on RA6 and RA7
;     OSC = INTIO7         Internal oscillator block, CLKO function on RA6, port function on RA7
;
;   Fail-Safe Clock Monitor Enable bit:
CONFIG FCMEN = OFF;        Fail-Safe Clock Monitor disabled
;     FCMEN = ON           Fail-Safe Clock Monitor enabled
;
;   Internal/External Oscillator Switchover bit:
CONFIG IESO = OFF;         Oscillator Switchover mode disabled
;CONFIG IESO = ON;          Oscillator Switchover mode enabled
;
;=====  CONFIG2L  =====
;   Power-up Timer Enable bit:
;     PWRT = ON            PWRT enabled
CONFIG PWRT = OFF;         PWRT disabled
;
;   Brown-out Reset Enable bits:
CONFIG BOREN = OFF;        Brown-out Reset disabled in hardware and software
;CONFIG BOREN = ON;         Brown-out Reset enabled and controlled by software (SBOREN is enabled)
;     BOREN = NOSLP        Brown-out Reset enabled in hardware only and disabled in Sleep mode (SBOREN is disabled)
;     BOREN = SBORDIS      Brown-out Reset enabled in hardware only (SBOREN is disabled)
;
;   Brown Out Reset Voltage bits:
;     BORV = 0             Maximum setting
;     BORV = 1             
;     BORV = 2             
;     BORV = 3             Minimum setting
;
;   Watchdog Timer Enable bit:
CONFIG WDT = OFF;          WDT disabled (control is placed on the SWDTEN bit)
;     WDT = ON             WDT enabled
;
;=====  CONFIG2H  =====
;   Watchdog Timer Postscale Select bits:
;     WDTPS = 1            1:1
;     WDTPS = 2            1:2
;     WDTPS = 4            1:4
;     WDTPS = 8            1:8
;     WDTPS = 16           1:16
;     WDTPS = 32           1:32
;     WDTPS = 64           1:64
;     WDTPS = 128          1:128
;     WDTPS = 256          1:256
;     WDTPS = 512          1:512
;     WDTPS = 1024         1:1024
;     WDTPS = 2048         1:2048
;     WDTPS = 4096         1:4096
;     WDTPS = 8192         1:8192
;     WDTPS = 16384        1:16384
;     WDTPS = 32768        1:32768
;
;=====  CONFIG3H  =====
;   CCP2 MUX bit:
;CONFIG CCP2MX = PORTBE;     CCP2 input/output is multiplexed with RB3
CONFIG CCP2MX = PORTC;     CCP2 input/output is multiplexed with RC1
;
;   PORTB A/D Enable bit:
CONFIG PBADEN = OFF;       PORTB<4:0> pins are configured as digital I/O on Reset
;     PBADEN = ON          PORTB<4:0> pins are configured as analog input channels on Reset
;
;   Low-Power Timer1 Oscillator Enable bit:
CONFIG LPT1OSC = OFF;      Timer1 configured for higher power operation
;     LPT1OSC = ON         Timer1 configured for low-power operation
;
;   MCLR Pin Enable bit:
;CONFIG MCLRE = OFF;        RE3 input pin enabled; MCLR disabled
CONFIG MCLRE = ON;         MCLR pin enabled; RE3 input pin disabled
;
;=====  CONFIG4L  =====
;   Stack Full/Underflow Reset Enable bit:
CONFIG STVREN = OFF;       Stack full/underflow will not cause Reset
;CONFIG STVREN = ON;        Stack full/underflow will cause Reset
;
;   Single-Supply ICSP Enable bit:
CONFIG LVP = OFF;          Single-Supply ICSP disabled
;     LVP = ON             Single-Supply ICSP enabled
;
;   Extended Instruction Set Enable bit:
CONFIG XINST = OFF;        Instruction set extension and Indexed Addressing mode disabled (Legacy mode)
;CONFIG XINST = ON;           Instruction set extension and Indexed Addressing mode enabled
;
;   Background Debugger Enable bit:
;CONFIG DEBUG = ON;         Background debugger enabled, RB6 and RB7 are dedicated to In-Circuit Debug
CONFIG DEBUG = OFF;       Background debugger disabled, RB6 and RB7 configured as general purpose I/O pins
;
;=====  CONFIG5L  =====
;   Code Protection bit:
;     CP0 = ON             Block 0 (000800-001FFFh) code-protected
CONFIG CP0 = OFF;          Block 0 (000800-001FFFh) not code-protected
;
;   Code Protection bit:
;     CP1 = ON             Block 1 (002000-003FFFh) code-protected
CONFIG CP1 = OFF;          Block 1 (002000-003FFFh) not code-protected
;
;   Code Protection bit:
;     CP2 = ON             Block 2 (004000-005FFFh) code-protected
CONFIG CP2 = OFF;          Block 2 (004000-005FFFh) not code-protected
;
;   Code Protection bit:
;     CP3 = ON             Block 3 (006000-007FFFh) code-protected
CONFIG CP3 = OFF;          Block 3 (006000-007FFFh) not code-protected
;
;=====  CONFIG5H  =====
;   Boot Block Code Protection bit:
;     CPB = ON             Boot block (000000-0007FFh) code-protected
CONFIG CPB = OFF;          Boot block (000000-0007FFh) not code-protected
;
;   Data EEPROM Code Protection bit:
;     CPD = ON             Data EEPROM code-protected
CONFIG CPD = OFF;          Data EEPROM not code-protected
;
;=====  CONFIG6L  =====
;   Write Protection bit:
;     WRT0 = ON            Block 0 (000800-001FFFh) write-protected
CONFIG WRT0 = OFF;         Block 0 (000800-001FFFh) not write-protected
;
;   Write Protection bit:
;     WRT1 = ON            Block 1 (002000-003FFFh) write-protected
CONFIG WRT1 = OFF;         Block 1 (002000-003FFFh) not write-protected
;
;   Write Protection bit:
;     WRT2 = ON            Block 2 (004000-005FFFh) write-protected
CONFIG WRT2 = OFF;         Block 2 (004000-005FFFh) not write-protected
;
;   Write Protection bit:
;     WRT3 = ON            Block 3 (006000-007FFFh) write-protected
CONFIG WRT3 = OFF;         Block 3 (006000-007FFFh) not write-protected
;
;=====  CONFIG6H  =====
;   Configuration Register Write Protection bit:
;     WRTC = ON            Configuration registers (300000-3000FFh) write-protected
CONFIG WRTC = OFF;         Configuration registers (300000-3000FFh) not write-protected
;
;   Boot Block Write Protection bit:
;     WRTB = ON            Boot block (000000-0007FFh) write-protected
CONFIG WRTB = OFF;         Boot block (000000-0007FFh) not write-protected
;
;   Data EEPROM Write Protection bit:
;     WRTD = ON            Data EEPROM write-protected
CONFIG WRTD = OFF;         Data EEPROM not write-protected
;
;=====  CONFIG7L  =====
;   Table Read Protection bit:
;     EBTR0 = ON           Block 0 (000800-001FFFh) protected from table reads executed in other blocks
CONFIG EBTR0 = OFF;        Block 0 (000800-001FFFh) not protected from table reads executed in other blocks
;
;   Table Read Protection bit:
;     EBTR1 = ON           Block 1 (002000-003FFFh) protected from table reads executed in other blocks
CONFIG EBTR1 = OFF;        Block 1 (002000-003FFFh) not protected from table reads executed in other blocks
;
;   Table Read Protection bit:
;     EBTR2 = ON           Block 2 (004000-005FFFh) protected from table reads executed in other blocks
CONFIG EBTR2 = OFF;        Block 2 (004000-005FFFh) not protected from table reads executed in other blocks
;
;   Table Read Protection bit:
;     EBTR3 = ON           Block 3 (006000-007FFFh) protected from table reads executed in other blocks
CONFIG EBTR3 = OFF;        Block 3 (006000-007FFFh) not protected from table reads executed in other blocks
;
;=====  CONFIG7H  =====
;   Boot Block Table Read Protection bit:
;     EBTRB = ON           Boot block (000000-0007FFh) protected from table reads executed in other blocks
CONFIG EBTRB = OFF;        Boot block (000000-0007FFh) not protected from table reads executed in other blocks
;
;==========================================================================