;==========================================
; MAIN.asm

;  
main:
		BCF		STATUS, C
		MOVF	FLAG_DS_Count, w
		ADDLW	-.5
		BTFSC	STATUS, C
		GOTO	Sleep_mode

		BTFSS	INT_ON_1sec, .0
		GOTO	main

		BTFSC	INT_ON_1msec, .0
		GOTO	TX_data

		GOTO	main
;==========================================

;  ,    CRC-8
READ_SIGN:
		CALL	RESET_WIRE

		delay_K	.68			;  68 

		;   
		BTFSC	PORT_DS, bit_DS
		GOTO	ERR_1W		; 

		;   !!!
		;BCF		PORT_Err, bit_Err

		delay_K	.256		;  256 

		MOVLW	0x33		;  " ROM"
		MOVWF	DATA_OUT
		CALL	TX_byte_1W	;  

		CALL	RX_byte_1W
		MOVF	DATA_IN, w
		MOVWF	FAMILYCODE
		CALL	RX_byte_1W
		MOVF	DATA_IN, w
		MOVWF	IDCODE0
		CALL	RX_byte_1W
		MOVF	DATA_IN, w
		MOVWF	IDCODE1
		CALL	RX_byte_1W
		MOVF	DATA_IN, w
		MOVWF	IDCODE2
		CALL	RX_byte_1W
		MOVF	DATA_IN, w
		MOVWF	IDCODE3
		CALL	RX_byte_1W
		MOVF	DATA_IN, w
		MOVWF	IDCODE4
		CALL	RX_byte_1W
		MOVF	DATA_IN, w
		MOVWF	IDCODE5
		CALL	RX_byte_1W
		MOVF	DATA_IN, w
		MOVWF	CRC
		RETURN
;==========================================

;  
TX_data:

		BCF		INT_ON_1msec, .0

		BTFSC	step_1_wire, .0
		GOTO	step_0
		BTFSC	step_1_wire, .1
		GOTO	step_1
		BTFSC	step_1_wire, .2
		GOTO	step_2
		BTFSC	step_1_wire, .3
		GOTO	step_3
		BTFSC	step_1_wire, .4
		GOTO	step_4
		BTFSC	step_1_wire, .5
		GOTO	step_5
		BTFSC	step_1_wire, .6
		GOTO	step_6
		BTFSC	step_1_wire, .7
		GOTO	step_7
;==========================================

step_0:
;=============== 0-  ================
		CALL	RESET_WIRE	;  

		delay_K	.68			;  68 

		;   
		BTFSC	PORT_DS, bit_DS
		GOTO	ERR_1W		; 

		;   !!!
		;BCF		PORT_Err, bit_Err

		delay_K	.256		;  256 

		MOVLW	b'00000010'
		MOVWF	step_1_wire
		GOTO	main

step_1:
;=============== 1-  ================
		MOVLW	0xCC		;  " ROM"
		MOVWF	DATA_OUT
		CALL	TX_byte_1W	;  
		MOVLW	b'00000100'
		MOVWF	step_1_wire
		GOTO	main

step_2:
;=============== 2-  ================
		;return
		MOVLW	0xBE		;  " "
		MOVWF	DATA_OUT
		CALL	TX_byte_1W	;  
		MOVLW	b'00001000'
		MOVWF	step_1_wire
		GOTO	main

step_3:
;=============== 3-  ================
		CALL	RX_byte_1W	;  
		MOVF	DATA_IN, w
		MOVWF	DATA_INL
		MOVLW	b'00010000'
		MOVWF	step_1_wire
		GOTO	main

step_4:
;=============== 4-  ================
		CALL	RX_byte_1W	;  
		MOVF	DATA_IN, w
		MOVWF	DATA_INH
		MOVLW	b'00100000'
		MOVWF	step_1_wire
		GOTO	main

		MOVLW	0x0
		MOVWF	DATA_INH

step_5:
;=============== 5-  ================
		CALL	RESET_WIRE	;  

		delay_K	.68			;  68 

		;   
		BTFSC	PORT_DS, bit_DS
		GOTO	ERR_1W		; 

		;   !!!
		;BCF		PORT_Err, bit_Err

		delay_K	.256		;  256 
		MOVLW	b'01000000'
		MOVWF	step_1_wire
		GOTO	main

step_6:
;=============== 6-  ================
		MOVLW	0xCC		;  " ROM"
		MOVWF	DATA_OUT
		CALL	TX_byte_1W	;  
		MOVLW	b'10000000'
		MOVWF	step_1_wire
		GOTO	main

step_7:
;=============== 7-  ================
		MOVLW	0x44		;  "  "
		MOVWF	DATA_OUT
		CALL	TX_byte_1W	;  
		MOVLW	b'00000001'
		MOVWF	step_1_wire
		CALL	ByteToDec
		BCF		INT_ON_1sec, .0
		GOTO	main

		;BCF	PORT_DS, bit_DS_pwr
;==========================================

;  
ERR_1W:
		;   !!!
		;BSF		PORT_Err, bit_Err

		MOVLW	.2
		MOVWF	FLAG_DS_read

		BCF		INT_ON_1sec, .0
		MOVLW	0x0A ; .10
		MOVWF	Hundreds
		MOVLW	0x0C ; .12
		MOVWF	Tens
		MOVLW	0x0D ; .13
		MOVWF	Ones
		MOVLW	0x0D ; .13
		MOVWF	Tenth
		BCF		FLAG_DS, .0
		BCF		FLAG_DS, .1
		GOTO	main
;==========================================

;  1 
TX_byte_1W:
		MOVLW	.8
		MOVWF	COUNT
LOOP_1:
		RRCF	DATA_OUT, f		;    
		BTFSC	STATUS, C		;    "C"
		GOTO	TX_1
		GOTO	TX_0
METKA_1:
		DECFSZ	COUNT, f
		GOTO	LOOP_1
		RETURN
;==========================================

;    "1"
TX_1:
		; PORT_DS, bit_DS   
		PORTout
		NOP
		; PORT_DS, bit_DS   
		PORTin
		delay_K	.56  			; 180  164
		NOP
		GOTO	METKA_1
;==========================================

;    "0"
TX_0:
		; PORT_DS, bit_DS   
		PORTout
		delay_K	.36				; 156 
		NOP
		NOP
		NOP
		NOP
		; PORT_DS, bit_DS   
		PORTin
		delay_K	.16				; 24 
		NOP
		NOP
		GOTO	METKA_1
;==========================================

;  1 
RX_byte_1W:
		MOVLW	.8
		MOVWF	COUNT
LOOP_2
		; PORT_DS, bit_DS   
		PORTout
		NOP
		; PORT_DS, bit_DS   
		PORTin

		;delay_K	.4			; 4 

		BCF		STATUS, C
		BTFSC	PORT_DS, bit_DS
		BSF		STATUS, C
		RRCF	DATA_IN, f		;     

		delay_K	.60				; 248 

		DECFSZ	COUNT, f
		GOTO	LOOP_2
		RETURN
;==========================================

;     RESET
RESET_WIRE:
		PORTout
		delay_K	.500			; 600 
		PORTin
		RETURN
;==========================================

Sleep_mode:
		;  
		BCF		PIE2, LVDIE
		BCF 	PIE1, .1			;   
		BCF 	PIR1, .1			;    

		MOVLW	(0<<GIE_GIEH)|(0<<PEIE_GIEL)|(0<<TMR0IE)|(0<<RBIE)|(0<<RBIF) ;   
		MOVWF	INTCON
		;BSF		INTCON2, RBPU


		;    
		;    
		MOVLW   b'00000110'			;    Fosc=31 , IDLEN == 0
        MOVWF   OSCCON

		;   2 (  )
		CLRF	T2CON				;  TMR2

		;    
		MOVLW	(0<<IRVST)|(0<<LVDEN)|(0<<LVDL3)|(0<<LVDL2)|(0<<LVDL1)|(0<<LVDL0)
		MOVWF	LVDCON

		;    
		CLRF	TRIS_DS
		CLRF	PORT_DS

		;BCF		PORT_DS, bit_DS
		;BCF		PORT_DS, bit_DS_pwr

		CLRF	PORT_CAT
		CLRF	PORT_LED

		SLEEP
;==========================================
