;   DS18B20  DS1820.
;    
;       .

#include <p18f2520.inc>
#include <Macro_function.asm>

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;  
#include <CONFIG_CPU.asm>


;==========================================
;  
		CBLOCK  0x00
;      
;  
w_temp			;      
status_temp		;  
bsr_temp		; (   )
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
DATA_IN
DATA_OUT
DATA_INL
DATA_INH

step_indication ;    
step_1_wire		;       

INT_ON_1sec		;    2 
INT_ON_1msec	;    1 
FLAG_DS			;       
; FLAG_DS == xxxxxx01 -  DS1820
; FLAG_DS == xxxxxx11 -  DS18B20
; FLAG_DS == xxxxx1xx -    
FLAG_DS_read	;    
FLAG_DS_Count	; -        SLEEP

FAMILYCODE
IDCODE0
IDCODE1
IDCODE2
IDCODE3
IDCODE4
IDCODE5
CRC

Hundreds		; 
Tens			; 
Ones			; 
Tenth			; 
Minus			;  ""

COUNT
COUNT0
COUNT1
		ENDC

PORT_CAT	EQU  H'0F82'; PORTC
PORT_LED	EQU  H'0F81'; PORTB
PORT_DS		EQU  H'0F80'; PORTA
TRIS_DS		EQU  H'0F92'; TRISA
PORT_Err	EQU  H'0F80'; PORTA

bit_DS		EQU	 .1
bit_DS_pwr	EQU	 .0
bit_Err		EQU	 .4

;==========================================
		ORG 	0x000
		GOTO 	START

		ORG 	0x008
		GOTO 	High_Interrupt

		ORG 	0x018
		GOTO 	Low_Interrupt
;==========================================

START:
;  

;   "A"
		CLRF	PORTA
		CLRF	LATA
;   "A"
		;MOVLW   0x07
		MOVLW   0x0F
		MOVWF	ADCON1
		MOVLW   0x07
		MOVWF	CMCON
		CLRF	TRISA
		BSF		TRISA, bit_DS
;==========================================

;   "B"
		CLRF	PORTB
		CLRF	LATB
;   "B"
		MOVLW   0x0F
		MOVWF	ADCON1
		MOVLW	0x00
		MOVWF	TRISB
;==========================================

;   "C"
		CLRF	PORTC
		CLRF	LATC
;   "C"
		MOVLW	0x00
		MOVWF	TRISC
;==========================================

;  
		CLRF	ADCON0
		;MOVLW	0x07
		;MOVWF	ADCON1
;==========================================

;    
		MOVLW   b'11100110'			;    Fosc=4 
        MOVWF   OSCCON
;==========================================

;   2
;  
		CLRF	T2CON				;  TMR2
		;CLRF	TMR2				;    TMR2
		MOVLW	.209				; 209
		MOVWF	TMR2
		CLRF	INTCON				;  

		;  2
		MOVLW   .249				;     ...249
		MOVWF   PR2					;  2
		MOVLW   b'00011100' 		;  1:4,  1:1
		MOVWF   T2CON
;==========================================

;    
		MOVLW	(0<<LVDL3)|(1<<LVDL2)|(1<<LVDL1)|(1<<LVDL0)
		MOVWF	LVDCON
		BCF		PIE2, LVDIE
		BCF		INTCON, GIE_GIEH
		BSF		LVDCON, LVDEN
Lvd:	BTFSS	LVDCON, IRVST
		GOTO	Lvd
		BCF		PIR2, LVDIF
		BSF		PIE2, LVDIE
		BSF		INTCON, GIE_GIEH
;==========================================

;  

		BCF 	PIE1, .1			;   
		BCF 	PIR1, .1			;    

		MOVLW	(1<<GIE_GIEH)|(1<<PEIE_GIEL)|(0<<TMR0IE)|(0<<RBIE)|(0<<RBIF) ;   
		MOVWF	INTCON				;      

		BSF 	PIE1, .1			;   
		BSF		RCON, IPEN

;==========================================

		GOTO	JUMP
;       
conv_data:
		addwf 	PCL, f	; dec ; hex  ; 
		retlw	0xFA	;  0  ; 0x00 ; "0"
		retlw	0x22	;  1  ; 0x01 ; "1"
		retlw	0x79	;  2  ; 0x02 ; "2"
		retlw	0x6B	;  3  ; 0x03 ; "3"
		retlw	0xA3	;  4  ; 0x04 ; "4"
		retlw	0xCB	;  5  ; 0x05 ; "5"
		retlw	0xDB	;  6  ; 0x06 ; "6"
		retlw	0x62	;  7  ; 0x07 ; "7"
		retlw	0xFB	;  8  ; 0x08 ; "8"
		retlw	0xEB	;  9  ; 0x09 ; "9"
		retlw	0x00	; 10  ; 0x0A ;  
		retlw	0x01	; 11  ; 0x0B ; "-"
		retlw	0xD9	; 12  ; 0x0C ; "E"
		retlw	0x11	; 13  ; 0x0D ; "r"
		retlw	0x9B	; 14  ; 0x0E ; "b"
		retlw	0xF3	; 15  ; 0x0F ; "A"
		retlw	0x99	; 16  ; 0x10 ; "t"

;       
conv_tenth:
		addwf 	PCL, f	; dec ;	hex  ;
		retlw	.0		;  0  ;	0x00 ;
		retlw	.1		;  1  ;	0x01 ;
		retlw	.1		;  2  ;	0x02 ;
		retlw	.2		;  3  ;	0x03 ;
		retlw	.2		;  4  ;	0x04 ;
		retlw	.3		;  5  ;	0x05 ;
		retlw	.3		;  6  ;	0x06 ;
		retlw	.4		;  7  ;	0x07 ;
		retlw	.5		;  8  ;	0x08 ;
		retlw	.6		;  9  ;	0x09 ;
		retlw	.6		; 10  ;	0x0A ;
		retlw	.7		; 11  ;	0x0B ;
		retlw	.7		; 12  ;	0x0C ;
		retlw	.8		; 13  ;	0x0D ;
		retlw	.9		; 14  ;	0x0E ;
		retlw	.9		; 15  ;	0x0F ;
;==========================================

JUMP:

;   

		CLRF	PORTA
		CLRF	PORTB
		CLRF	PORTC

		;     
		BSF		PORT_DS, bit_DS_pwr

		MOVLW	b'00000001'
		MOVWF	step_indication
		MOVWF	step_1_wire

		CLRF	DATA_INL
		CLRF	DATA_INH
		CLRF	INT_ON_1sec		;    2 
		CLRF	INT_ON_1msec	;    1 
		CLRF	FLAG_DS
		CLRF	FLAG_DS_read
		CLRF	FLAG_DS_Count
		;CALL	READ_SIGN

		;CLRF	Hundreds		; 
		;CLRF	Tens			; 
		;CLRF	Ones			; 
		;CLRF	Tenth			;   
		MOVLW	0x0B
		MOVWF	Hundreds		; 
		MOVWF	Tens			; 
		MOVWF	Ones			; 
		MOVWF	Tenth			;   
		CLRF	Minus			;  ""

		CLRF	COUNT
		;CLRF	COUNT0
		;CLRF	COUNT1
		MOVLW	.189
		MOVWF	COUNT0
		MOVLW	.3
		MOVWF	COUNT1

		#include <MAIN.asm>
		#include <ByteToDec.asm>
		#include <Indication.asm>
;==========================================

High_Interrupt:

		;  
		MOVWF	w_temp
		SWAPF	STATUS, w
		MOVWF	status_temp
		SWAPF	BSR, w
		MOVWF	bsr_temp
		;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

		;   

		;     
		BTFSS	PIR2, LVDIF
		GOTO	int
		;BSF		PORTA, .3
		MOVLW	0x0A ; .10
		MOVWF	Hundreds
		MOVLW	0x0E ; .14
		MOVWF	Tens
		MOVLW	0x0F ; .15
		MOVWF	Ones
		MOVLW	0x10 ; .16
		MOVWF	Tenth
		BCF		PIE2, LVDIE
		BCF		FLAG_DS, .2			;      Indication.asm

int:	BSF		INT_ON_1msec, .0	;  

		INCFSZ	COUNT0, f
		GOTO	INTERR1
		INCF	COUNT1, f

INTERR1:
		;  COUNT0 = 194
		MOVLW	.194
		SUBWF	COUNT0, w
		BTFSS	STATUS, Z
		GOTO	INTERR2
		;  COUNT1 = 7
		MOVLW	.3
		SUBWF	COUNT1, w
		BTFSS	STATUS, Z
		GOTO	INTERR2

		;     1 
		CLRF	COUNT0
		CLRF	COUNT1
		INCF	FLAG_DS_Count, f	;  -        SLEEP

		BCF		STATUS, .0
		MOVF	FLAG_DS_read, w
		ADDLW	-.2
		BTFSC	STATUS, C			;      2 
		GOTO	INTERR2
		INCF	FLAG_DS_read, f		;     
		BSF		INT_ON_1sec, .0		;    

INTERR2:
		BTFSC	PIR2, LVDIF			;     
		GOTO	loop2
		BCF		STATUS, .0
		MOVF	FLAG_DS_read, w
		SUBLW	.1
		BTFSS	STATUS, C			;      1 
		GOTO	loop2
		;   ,   "----"
		MOVLW	0x0B
		MOVWF	Hundreds			; 
		MOVWF	Tens				; 
		MOVWF	Ones				; 
		MOVWF	Tenth				;   
		BCF		FLAG_DS, .2			;      Indication.asm

loop2:
		CALL	Indication

		;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		;      STATUS
		;      
		SWAPF	status_temp, w
		MOVWF	STATUS
		SWAPF	bsr_temp, w
		MOVWF	BSR
		SWAPF	w_temp, f
		SWAPF	w_temp, w
		;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

		;   
		BCF		PIR1, TMR2IF		;   TMR2IF -   TMR2
		BCF		PIR2, LVDIF			;   LVDIF -   LVD

		;    TMR2 2
		CLRF 	TMR2

		RETFIE

;==========================================
Low_Interrupt:

		;  
		MOVWF	w_temp
		SWAPF	STATUS, w
		MOVWF	status_temp
		SWAPF	BSR, w
		MOVWF	bsr_temp
		;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

		;   
		NOP
		;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

		;      STATUS
		;      
		SWAPF	status_temp, w
		MOVWF	STATUS
		SWAPF	bsr_temp, w
		MOVWF	BSR
		SWAPF	w_temp, f
		SWAPF	w_temp, w
		;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

		;   
		BCF		PIR1, TMR2IF		;   TMR2IF -   TMR2

		;    TMR2 2
		CLRF 	TMR2

		RETFIE
;==========================================

		END
;==========================================